unit uMain;

{$mode objfpc}{$H+}

interface

uses
 Classes, SysUtils, FileUtil, ZConnection, Forms, Controls, Graphics, Dialogs,
	StdCtrls, Spin, ZDataset;

type

	{ TCThread }

 TCThread = class(TThread)
 private
  lConnection: TZConnection;
  lQuery: TZQuery;
  ID_: Integer;
 protected
  { Protected declarations }
  procedure Execute; override;
  procedure LogMain;
 public
   constructor Create(ID: Integer);
   destructor Destroy; override;
 end;

 { TfrmMain }

 TfrmMain = class(TForm)
		Button2: TButton;
  Label1: TLabel;
  Memo1: TMemo;
  seThreadCount: TSpinEdit;
  ZConnection1: TZConnection;
  procedure Button2Click(Sender: TObject);
  procedure FormCreate(Sender: TObject);
 private
  //lThread: TLogThread;
  //tm: TMySQLTest;
  cThread: TCThread;
 public
  { public declarations }
 end;

var
 frmMain: TfrmMain;
 LPath: string;

const
  dbLibFileName = 'libmysql.dll';

  db_Host = '127.0.0.1';  // <-- or change
  db_Port = 3306;
  db_Name = 'PLEASE FILL IN';
  db_username = 'PLEASE FILL IN';
  db_password = 'PLEASE FILL IN';

implementation

{$R *.lfm}

{ TCThread }

procedure TCThread.Execute;
begin
	  lQuery:=TZQuery.Create(nil);
	  lQuery.Connection:=lConnection;

  try
    lQuery.SQL.Text:='select * from `log`';   //<- please, change for your table
    lQuery.Open;
	 finally
    Synchronize(@LogMain);
	 end;
end;

procedure TCThread.LogMain;
begin
  frmMain.Memo1.Lines.Add('Thread ' + IntToStr(ID_) + ' finished');
end;

constructor TCThread.Create(ID: Integer);
begin
  inherited Create(False);
  FreeOnTerminate:=True;
  ID_:=ID;
  lConnection:=TZConnection.Create(nil);
  //lConnection.LibraryLocation:=LPath + dbLibFileName;
  lConnection.HostName:='localhost';                    // <--- change const
  //lConnection.Port:=db_Port;                        // <--- change const
  lConnection.Database:='zeoslib';                    // <--- change const
  lConnection.User:='root';                    // <--- change const
  lConnection.Password:='masterkey';                // <--- change const
  lConnection.LoginPrompt:=False;
  lConnection.Protocol:='mysql';
  lConnection.ClientCodepage:='UTF8';
  //lConnection.AutoEncodeStrings:=True; //<- you don't need this here this is an option which
  lConnection.UseMetadata:=True;

  try
    lConnection.Connect;
  except
    lConnection.Free;
    Exit;
  end;
end;

destructor TCThread.Destroy;
begin
  lQuery.Close;
  lQuery.Free;

  lConnection.Disconnect;
  lConnection.Free;

  inherited Destroy;
end;

{ TfrmMain }

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  LPath:=IncludeTrailingPathDelimiter(ExtractFilePath(Application.ExeName));
  {ThreadUnsafe calls before a connect happens:
  //http://dev.mysql.com/doc/refman/5.7/en/mysql-library-init.html
  //mysql_library_init(ServerArgsLen, ServerArgs, @SERVER_GROUPS); //<<<-- Isn't threadsafe
  //http://dev.mysql.com/doc/refman/5.7/en/mysql-server-init.html
  //mysql_server_init(ServerArgsLen, ServerArgs, @SERVER_GROUPS); //<<<-- Isn't threadsafe

  another thing:
  http://bugs.mysql.com/bug.php?id=79510
  }
  //ZConnection1.Connect; //<- if this line is commented, a SQL Socket Error exception is raised
                        //   SQLError: Can't create TCP/IP socket (10093)
   //!!!  >>> this is wrong!!                   //   this is because the libmysql is not loaded in the main thread...


                        //   some kind of a miss/poorly written mysql part???
end;

procedure TfrmMain.Button2Click(Sender: TObject);
var
  I: Integer;
begin
 for I:=1 to seThreadCount.Value do
  TCThread.Create(I);
end;

end.
